include:
  - template: SAST.gitlab-ci.yml
  - template: License-Scanning.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: Secret-Detection.gitlab-ci.yml

# workflow rules are not extended by scanner jobs, need to override them manually
# TODO: remove when https://gitlab.com/gitlab-org/gitlab/-/issues/218444 is done

.rules-for-scanners: &rules-for-scanners
  stage: analyze
  needs: []
  rules:
    # For merge requests, create a pipeline.
    - if: '$CI_MERGE_REQUEST_IID'
    # For `master` branch, create a pipeline (this includes on schedules, pushes, merges, etc.).
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
    # For tags, create a pipeline.
    - if: '$CI_COMMIT_TAG'
    # For stable, and security branches, create a pipeline.
    - if: '$CI_COMMIT_BRANCH =~ /^[\d-]+-stable$/'

secret_detection:
  stage: analyze
  needs: []
  rules:
    - if: '$CI_MERGE_REQUEST_EVENT_TYPE == "merge_train"'
      when: never
    - if: '$CI_MERGE_REQUEST_IID'
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'

semgrep-sast:
  # using the `extends` keyword doesn't trigger some jobs so we need to use anchors
  <<: *rules-for-scanners

license_scanning:
  # using the `extends` keyword doesn't trigger some jobs so we need to use anchors
  <<: *rules-for-scanners

gemnasium-dependency_scanning:
  # using the `extends` keyword doesn't trigger some jobs so we need to use anchors
  <<: *rules-for-scanners
